/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
)

// checks if the CxTemplateInstallationCreateData type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CxTemplateInstallationCreateData{}

// CxTemplateInstallationCreateData struct for CxTemplateInstallationCreateData
type CxTemplateInstallationCreateData struct {
	OrganizationId *string `json:"organization_id,omitempty"`
	ChannelId *string `json:"channel_id,omitempty"`
}

// NewCxTemplateInstallationCreateData instantiates a new CxTemplateInstallationCreateData object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCxTemplateInstallationCreateData() *CxTemplateInstallationCreateData {
	this := CxTemplateInstallationCreateData{}
	return &this
}

// NewCxTemplateInstallationCreateDataWithDefaults instantiates a new CxTemplateInstallationCreateData object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCxTemplateInstallationCreateDataWithDefaults() *CxTemplateInstallationCreateData {
	this := CxTemplateInstallationCreateData{}
	return &this
}

// GetOrganizationId returns the OrganizationId field value if set, zero value otherwise.
func (o *CxTemplateInstallationCreateData) GetOrganizationId() string {
	if o == nil || IsNil(o.OrganizationId) {
		var ret string
		return ret
	}
	return *o.OrganizationId
}

// GetOrganizationIdOk returns a tuple with the OrganizationId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplateInstallationCreateData) GetOrganizationIdOk() (*string, bool) {
	if o == nil || IsNil(o.OrganizationId) {
		return nil, false
	}
	return o.OrganizationId, true
}

// HasOrganizationId returns a boolean if a field has been set.
func (o *CxTemplateInstallationCreateData) HasOrganizationId() bool {
	if o != nil && !IsNil(o.OrganizationId) {
		return true
	}

	return false
}

// SetOrganizationId gets a reference to the given string and assigns it to the OrganizationId field.
func (o *CxTemplateInstallationCreateData) SetOrganizationId(v string) {
	o.OrganizationId = &v
}

// GetChannelId returns the ChannelId field value if set, zero value otherwise.
func (o *CxTemplateInstallationCreateData) GetChannelId() string {
	if o == nil || IsNil(o.ChannelId) {
		var ret string
		return ret
	}
	return *o.ChannelId
}

// GetChannelIdOk returns a tuple with the ChannelId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplateInstallationCreateData) GetChannelIdOk() (*string, bool) {
	if o == nil || IsNil(o.ChannelId) {
		return nil, false
	}
	return o.ChannelId, true
}

// HasChannelId returns a boolean if a field has been set.
func (o *CxTemplateInstallationCreateData) HasChannelId() bool {
	if o != nil && !IsNil(o.ChannelId) {
		return true
	}

	return false
}

// SetChannelId gets a reference to the given string and assigns it to the ChannelId field.
func (o *CxTemplateInstallationCreateData) SetChannelId(v string) {
	o.ChannelId = &v
}

func (o CxTemplateInstallationCreateData) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CxTemplateInstallationCreateData) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.OrganizationId) {
		toSerialize["organization_id"] = o.OrganizationId
	}
	if !IsNil(o.ChannelId) {
		toSerialize["channel_id"] = o.ChannelId
	}
	return toSerialize, nil
}

type NullableCxTemplateInstallationCreateData struct {
	value *CxTemplateInstallationCreateData
	isSet bool
}

func (v NullableCxTemplateInstallationCreateData) Get() *CxTemplateInstallationCreateData {
	return v.value
}

func (v *NullableCxTemplateInstallationCreateData) Set(val *CxTemplateInstallationCreateData) {
	v.value = val
	v.isSet = true
}

func (v NullableCxTemplateInstallationCreateData) IsSet() bool {
	return v.isSet
}

func (v *NullableCxTemplateInstallationCreateData) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCxTemplateInstallationCreateData(val *CxTemplateInstallationCreateData) *NullableCxTemplateInstallationCreateData {
	return &NullableCxTemplateInstallationCreateData{value: val, isSet: true}
}

func (v NullableCxTemplateInstallationCreateData) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCxTemplateInstallationCreateData) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


